import { Observable, PartialObserver as Listener, Subscription } from 'rxjs'
import { PushEvent } from './baseTypes'
export { Listener, Subscription }
export interface ObservableComponent {
    observe: <T>(
        propName?: string,
        valueTransformer?: (val: any) => T
    ) => Observable<T>
    fromEvent: <T>(
        eventName: string,
        valueTransformer?: (val: any) => T
    ) => Observable<T>
    mount: Observable<any>
    unmount: Observable<any>
    pushEvent: PushEvent
    useEvent: <T>(eventName: string) => [Observable<T>, (val: T) => any]
}
export declare type Aperture<P, E, C = any> = (
    initialProps: P,
    initialContext: C
) => (component: ObservableComponent) => Observable<E>
export declare const subscribeToSink: <T>(
    sink: Observable<T>,
    next: (val: T) => void,
    error?: (error: any) => void
) => Subscription
export declare const createComponent: <P>(
    instance: any,
    dataObservable: any,
    pushEvent: any
) => ObservableComponent
