/// <reference types="react" />
import * as React from 'react'
import { Handler, ErrorHandler, PushEvent } from './baseTypes'
import { Aperture } from './observable'
export interface State {
    replace?: boolean
    props: object
    renderEffect: boolean
    children: React.ReactNode | null
}
export declare const withEffects: <P, E, CP = P, C = any>(
    handler: Handler<P, E, C>,
    errorHandler?: ErrorHandler<P, C>,
    Context?: React.Context<C>
) => (
    aperture: Aperture<P, E, C>
) => (
    BaseComponent?: React.ComponentType<
        CP & {
            pushEvent: PushEvent
        }
    >
) => React.ComponentClass<P>
